// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"
	"gochassis/ent/chatroom"
	"gochassis/ent/post"
	"gochassis/ent/profile"
	"gochassis/ent/schema"
	"time"

	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
)

// PostCreate is the builder for creating a Post entity.
type PostCreate struct {
	config
	mutation *PostMutation
	hooks    []Hook
}

// SetImage sets the "image" field.
func (pc *PostCreate) SetImage(s string) *PostCreate {
	pc.mutation.SetImage(s)
	return pc
}

// SetContent sets the "content" field.
func (pc *PostCreate) SetContent(s string) *PostCreate {
	pc.mutation.SetContent(s)
	return pc
}

// SetProfileDisplayname sets the "profile_displayname" field.
func (pc *PostCreate) SetProfileDisplayname(s string) *PostCreate {
	pc.mutation.SetProfileDisplayname(s)
	return pc
}

// SetProfileBirthYear sets the "profile_birth_year" field.
func (pc *PostCreate) SetProfileBirthYear(i int16) *PostCreate {
	pc.mutation.SetProfileBirthYear(i)
	return pc
}

// SetNillableProfileBirthYear sets the "profile_birth_year" field if the given value is not nil.
func (pc *PostCreate) SetNillableProfileBirthYear(i *int16) *PostCreate {
	if i != nil {
		pc.SetProfileBirthYear(*i)
	}
	return pc
}

// SetProfileGender sets the "profile_gender" field.
func (pc *PostCreate) SetProfileGender(s string) *PostCreate {
	pc.mutation.SetProfileGender(s)
	return pc
}

// SetNillableProfileGender sets the "profile_gender" field if the given value is not nil.
func (pc *PostCreate) SetNillableProfileGender(s *string) *PostCreate {
	if s != nil {
		pc.SetProfileGender(*s)
	}
	return pc
}

// SetCoordinates sets the "coordinates" field.
func (pc *PostCreate) SetCoordinates(s *schema.Point) *PostCreate {
	pc.mutation.SetCoordinates(s)
	return pc
}

// SetCreatedAt sets the "created_at" field.
func (pc *PostCreate) SetCreatedAt(t time.Time) *PostCreate {
	pc.mutation.SetCreatedAt(t)
	return pc
}

// SetNillableCreatedAt sets the "created_at" field if the given value is not nil.
func (pc *PostCreate) SetNillableCreatedAt(t *time.Time) *PostCreate {
	if t != nil {
		pc.SetCreatedAt(*t)
	}
	return pc
}

// SetUpdatedAt sets the "updated_at" field.
func (pc *PostCreate) SetUpdatedAt(t time.Time) *PostCreate {
	pc.mutation.SetUpdatedAt(t)
	return pc
}

// SetNillableUpdatedAt sets the "updated_at" field if the given value is not nil.
func (pc *PostCreate) SetNillableUpdatedAt(t *time.Time) *PostCreate {
	if t != nil {
		pc.SetUpdatedAt(*t)
	}
	return pc
}

// SetDeletedAt sets the "deleted_at" field.
func (pc *PostCreate) SetDeletedAt(t time.Time) *PostCreate {
	pc.mutation.SetDeletedAt(t)
	return pc
}

// SetNillableDeletedAt sets the "deleted_at" field if the given value is not nil.
func (pc *PostCreate) SetNillableDeletedAt(t *time.Time) *PostCreate {
	if t != nil {
		pc.SetDeletedAt(*t)
	}
	return pc
}

// SetReplyTo sets the "reply_to" field.
func (pc *PostCreate) SetReplyTo(i int) *PostCreate {
	pc.mutation.SetReplyTo(i)
	return pc
}

// SetNillableReplyTo sets the "reply_to" field if the given value is not nil.
func (pc *PostCreate) SetNillableReplyTo(i *int) *PostCreate {
	if i != nil {
		pc.SetReplyTo(*i)
	}
	return pc
}

// AddChatRoomIDs adds the "chat_rooms" edge to the ChatRoom entity by IDs.
func (pc *PostCreate) AddChatRoomIDs(ids ...int) *PostCreate {
	pc.mutation.AddChatRoomIDs(ids...)
	return pc
}

// AddChatRooms adds the "chat_rooms" edges to the ChatRoom entity.
func (pc *PostCreate) AddChatRooms(c ...*ChatRoom) *PostCreate {
	ids := make([]int, len(c))
	for i := range c {
		ids[i] = c[i].ID
	}
	return pc.AddChatRoomIDs(ids...)
}

// SetPostedByID sets the "posted_by" edge to the Profile entity by ID.
func (pc *PostCreate) SetPostedByID(id int) *PostCreate {
	pc.mutation.SetPostedByID(id)
	return pc
}

// SetPostedBy sets the "posted_by" edge to the Profile entity.
func (pc *PostCreate) SetPostedBy(p *Profile) *PostCreate {
	return pc.SetPostedByID(p.ID)
}

// AddLikedByIDs adds the "liked_by" edge to the Profile entity by IDs.
func (pc *PostCreate) AddLikedByIDs(ids ...int) *PostCreate {
	pc.mutation.AddLikedByIDs(ids...)
	return pc
}

// AddLikedBy adds the "liked_by" edges to the Profile entity.
func (pc *PostCreate) AddLikedBy(p ...*Profile) *PostCreate {
	ids := make([]int, len(p))
	for i := range p {
		ids[i] = p[i].ID
	}
	return pc.AddLikedByIDs(ids...)
}

// SetReplyToEdgeID sets the "reply_to_edge" edge to the Post entity by ID.
func (pc *PostCreate) SetReplyToEdgeID(id int) *PostCreate {
	pc.mutation.SetReplyToEdgeID(id)
	return pc
}

// SetNillableReplyToEdgeID sets the "reply_to_edge" edge to the Post entity by ID if the given value is not nil.
func (pc *PostCreate) SetNillableReplyToEdgeID(id *int) *PostCreate {
	if id != nil {
		pc = pc.SetReplyToEdgeID(*id)
	}
	return pc
}

// SetReplyToEdge sets the "reply_to_edge" edge to the Post entity.
func (pc *PostCreate) SetReplyToEdge(p *Post) *PostCreate {
	return pc.SetReplyToEdgeID(p.ID)
}

// AddReplyIDs adds the "replies" edge to the Post entity by IDs.
func (pc *PostCreate) AddReplyIDs(ids ...int) *PostCreate {
	pc.mutation.AddReplyIDs(ids...)
	return pc
}

// AddReplies adds the "replies" edges to the Post entity.
func (pc *PostCreate) AddReplies(p ...*Post) *PostCreate {
	ids := make([]int, len(p))
	for i := range p {
		ids[i] = p[i].ID
	}
	return pc.AddReplyIDs(ids...)
}

// Mutation returns the PostMutation object of the builder.
func (pc *PostCreate) Mutation() *PostMutation {
	return pc.mutation
}

// Save creates the Post in the database.
func (pc *PostCreate) Save(ctx context.Context) (*Post, error) {
	pc.defaults()
	return withHooks[*Post, PostMutation](ctx, pc.sqlSave, pc.mutation, pc.hooks)
}

// SaveX calls Save and panics if Save returns an error.
func (pc *PostCreate) SaveX(ctx context.Context) *Post {
	v, err := pc.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (pc *PostCreate) Exec(ctx context.Context) error {
	_, err := pc.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (pc *PostCreate) ExecX(ctx context.Context) {
	if err := pc.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (pc *PostCreate) defaults() {
	if _, ok := pc.mutation.CreatedAt(); !ok {
		v := post.DefaultCreatedAt()
		pc.mutation.SetCreatedAt(v)
	}
	if _, ok := pc.mutation.UpdatedAt(); !ok {
		v := post.DefaultUpdatedAt()
		pc.mutation.SetUpdatedAt(v)
	}
}

// check runs all checks and user-defined validators on the builder.
func (pc *PostCreate) check() error {
	if _, ok := pc.mutation.Image(); !ok {
		return &ValidationError{Name: "image", err: errors.New(`ent: missing required field "Post.image"`)}
	}
	if v, ok := pc.mutation.Image(); ok {
		if err := post.ImageValidator(v); err != nil {
			return &ValidationError{Name: "image", err: fmt.Errorf(`ent: validator failed for field "Post.image": %w`, err)}
		}
	}
	if _, ok := pc.mutation.Content(); !ok {
		return &ValidationError{Name: "content", err: errors.New(`ent: missing required field "Post.content"`)}
	}
	if v, ok := pc.mutation.Content(); ok {
		if err := post.ContentValidator(v); err != nil {
			return &ValidationError{Name: "content", err: fmt.Errorf(`ent: validator failed for field "Post.content": %w`, err)}
		}
	}
	if _, ok := pc.mutation.ProfileDisplayname(); !ok {
		return &ValidationError{Name: "profile_displayname", err: errors.New(`ent: missing required field "Post.profile_displayname"`)}
	}
	if v, ok := pc.mutation.ProfileDisplayname(); ok {
		if err := post.ProfileDisplaynameValidator(v); err != nil {
			return &ValidationError{Name: "profile_displayname", err: fmt.Errorf(`ent: validator failed for field "Post.profile_displayname": %w`, err)}
		}
	}
	if _, ok := pc.mutation.Coordinates(); !ok {
		return &ValidationError{Name: "coordinates", err: errors.New(`ent: missing required field "Post.coordinates"`)}
	}
	if _, ok := pc.mutation.CreatedAt(); !ok {
		return &ValidationError{Name: "created_at", err: errors.New(`ent: missing required field "Post.created_at"`)}
	}
	if _, ok := pc.mutation.UpdatedAt(); !ok {
		return &ValidationError{Name: "updated_at", err: errors.New(`ent: missing required field "Post.updated_at"`)}
	}
	if _, ok := pc.mutation.PostedByID(); !ok {
		return &ValidationError{Name: "posted_by", err: errors.New(`ent: missing required edge "Post.posted_by"`)}
	}
	return nil
}

func (pc *PostCreate) sqlSave(ctx context.Context) (*Post, error) {
	if err := pc.check(); err != nil {
		return nil, err
	}
	_node, _spec := pc.createSpec()
	if err := sqlgraph.CreateNode(ctx, pc.driver, _spec); err != nil {
		if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	id := _spec.ID.Value.(int64)
	_node.ID = int(id)
	pc.mutation.id = &_node.ID
	pc.mutation.done = true
	return _node, nil
}

func (pc *PostCreate) createSpec() (*Post, *sqlgraph.CreateSpec) {
	var (
		_node = &Post{config: pc.config}
		_spec = sqlgraph.NewCreateSpec(post.Table, sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt))
	)
	if value, ok := pc.mutation.Image(); ok {
		_spec.SetField(post.FieldImage, field.TypeString, value)
		_node.Image = value
	}
	if value, ok := pc.mutation.Content(); ok {
		_spec.SetField(post.FieldContent, field.TypeString, value)
		_node.Content = value
	}
	if value, ok := pc.mutation.ProfileDisplayname(); ok {
		_spec.SetField(post.FieldProfileDisplayname, field.TypeString, value)
		_node.ProfileDisplayname = value
	}
	if value, ok := pc.mutation.ProfileBirthYear(); ok {
		_spec.SetField(post.FieldProfileBirthYear, field.TypeInt16, value)
		_node.ProfileBirthYear = value
	}
	if value, ok := pc.mutation.ProfileGender(); ok {
		_spec.SetField(post.FieldProfileGender, field.TypeString, value)
		_node.ProfileGender = value
	}
	if value, ok := pc.mutation.Coordinates(); ok {
		_spec.SetField(post.FieldCoordinates, field.TypeOther, value)
		_node.Coordinates = value
	}
	if value, ok := pc.mutation.CreatedAt(); ok {
		_spec.SetField(post.FieldCreatedAt, field.TypeTime, value)
		_node.CreatedAt = value
	}
	if value, ok := pc.mutation.UpdatedAt(); ok {
		_spec.SetField(post.FieldUpdatedAt, field.TypeTime, value)
		_node.UpdatedAt = value
	}
	if value, ok := pc.mutation.DeletedAt(); ok {
		_spec.SetField(post.FieldDeletedAt, field.TypeTime, value)
		_node.DeletedAt = value
	}
	if nodes := pc.mutation.ChatRoomsIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   post.ChatRoomsTable,
			Columns: []string{post.ChatRoomsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chatroom.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges = append(_spec.Edges, edge)
	}
	if nodes := pc.mutation.PostedByIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   post.PostedByTable,
			Columns: []string{post.PostedByColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(profile.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_node.profile_posts = &nodes[0]
		_spec.Edges = append(_spec.Edges, edge)
	}
	if nodes := pc.mutation.LikedByIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: true,
			Table:   post.LikedByTable,
			Columns: post.LikedByPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(profile.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges = append(_spec.Edges, edge)
	}
	if nodes := pc.mutation.ReplyToEdgeIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   post.ReplyToEdgeTable,
			Columns: []string{post.ReplyToEdgeColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_node.ReplyTo = nodes[0]
		_spec.Edges = append(_spec.Edges, edge)
	}
	if nodes := pc.mutation.RepliesIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   post.RepliesTable,
			Columns: []string{post.RepliesColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges = append(_spec.Edges, edge)
	}
	return _node, _spec
}

// PostCreateBulk is the builder for creating many Post entities in bulk.
type PostCreateBulk struct {
	config
	builders []*PostCreate
}

// Save creates the Post entities in the database.
func (pcb *PostCreateBulk) Save(ctx context.Context) ([]*Post, error) {
	specs := make([]*sqlgraph.CreateSpec, len(pcb.builders))
	nodes := make([]*Post, len(pcb.builders))
	mutators := make([]Mutator, len(pcb.builders))
	for i := range pcb.builders {
		func(i int, root context.Context) {
			builder := pcb.builders[i]
			builder.defaults()
			var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
				mutation, ok := m.(*PostMutation)
				if !ok {
					return nil, fmt.Errorf("unexpected mutation type %T", m)
				}
				if err := builder.check(); err != nil {
					return nil, err
				}
				builder.mutation = mutation
				var err error
				nodes[i], specs[i] = builder.createSpec()
				if i < len(mutators)-1 {
					_, err = mutators[i+1].Mutate(root, pcb.builders[i+1].mutation)
				} else {
					spec := &sqlgraph.BatchCreateSpec{Nodes: specs}
					// Invoke the actual operation on the latest mutation in the chain.
					if err = sqlgraph.BatchCreate(ctx, pcb.driver, spec); err != nil {
						if sqlgraph.IsConstraintError(err) {
							err = &ConstraintError{msg: err.Error(), wrap: err}
						}
					}
				}
				if err != nil {
					return nil, err
				}
				mutation.id = &nodes[i].ID
				if specs[i].ID.Value != nil {
					id := specs[i].ID.Value.(int64)
					nodes[i].ID = int(id)
				}
				mutation.done = true
				return nodes[i], nil
			})
			for i := len(builder.hooks) - 1; i >= 0; i-- {
				mut = builder.hooks[i](mut)
			}
			mutators[i] = mut
		}(i, ctx)
	}
	if len(mutators) > 0 {
		if _, err := mutators[0].Mutate(ctx, pcb.builders[0].mutation); err != nil {
			return nil, err
		}
	}
	return nodes, nil
}

// SaveX is like Save, but panics if an error occurs.
func (pcb *PostCreateBulk) SaveX(ctx context.Context) []*Post {
	v, err := pcb.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (pcb *PostCreateBulk) Exec(ctx context.Context) error {
	_, err := pcb.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (pcb *PostCreateBulk) ExecX(ctx context.Context) {
	if err := pcb.Exec(ctx); err != nil {
		panic(err)
	}
}
